KUBERNETES(1)(kubernetes)

Eric Paris Jan 2015

NAME

kubectl delete - Delete resources by file names, stdin, resources and names, or by resources and label selector

SYNOPSIS

kubectl delete [OPTIONS]

DESCRIPTION

Delete resources by file names, stdin, resources and names, or by resources and label selector.

JSON and YAML formats are accepted. Only one type of argument may be specified: file names, resources and names, or resources and label selector.

Some resources, such as pods, support graceful deletion. These resources define a default period before they are forcibly terminated (the grace period) but you may override that value with the --grace-period flag, or pass --now to set a grace-period of 1. Because these resources often represent entities in the cluster, deletion may not be acknowledged immediately. If the node hosting a pod is down or cannot reach the API server, termination may take significantly longer than the grace period. To force delete a resource, you must specify the --force flag. Note: only a subset of resources support graceful deletion. In absence of the support, the --grace-period flag is ignored.

IMPORTANT: Force deleting pods does not wait for confirmation that the pod's processes have been terminated, which can leave those processes running until the node detects the deletion and completes graceful deletion. If your processes use shared storage or talk to a remote API and depend on the name of the pod to identify themselves, force deleting those pods may result in multiple processes running on different machines using the same identification which may lead to data corruption or inconsistency. Only force delete pods when you are sure the pod is terminated, or if your application can tolerate multiple copies of the same pod running at once. Also, if you force delete pods, the scheduler may place new pods on those nodes before the node has released those resources and causing those pods to be evicted immediately.

Note that the delete command does NOT do resource version checks, so if someone submits an update to a resource right when you submit a delete, their update will be lost along with the rest of the resource.

After a CustomResourceDefinition is deleted, invalidation of discovery cache may take up to 6 hours. If you don't want to wait, you might want to run "kubectl api-resources" to refresh the discovery cache.

OPTIONS

--all=false
    Delete all resources, in the namespace of the specified resource types.

-A, --all-namespaces=false
    If present, list the requested object(s) across all namespaces. Namespace in current context is ignored even if specified with --namespace.

--cascade="background"
    Must be "background", "orphan", or "foreground". Selects the deletion cascading strategy for the dependents (e.g. Pods created by a ReplicationController). Defaults to background.

--dry-run="none"
    Must be "none", "server", or "client". If client strategy, only print the object that would be sent, without sending it. If server strategy, submit server-side request without persisting the resource.

--field-selector=""
    Selector (field query) to filter on, supports '=', '==', and '!='.(e.g. --field-selector key1=value1,key2=value2). The server only supports a limited number of field queries per type.

-f, --filename=[]
    containing the resource to delete.

--force=false
    If true, immediately remove resources from API and bypass graceful deletion. Note that immediate deletion of some resources may result in inconsistency or data loss and requires confirmation.

--grace-period=-1
    Period of time in seconds given to the resource to terminate gracefully. Ignored if negative. Set to 1 for immediate shutdown. Can only be set to 0 when --force is true (force deletion).

--ignore-not-found=false
    Treat "resource not found" as a successful delete. Defaults to "true" when --all is specified.

-i, --interactive=false
    If true, delete resource only when user confirms.

-k, --kustomize=""
    Process a kustomization directory. This flag can't be used together with -f or -R.

--now=false
    If true, resources are signaled for immediate shutdown (same as --grace-period=1).

-o, --output=""
    Output mode. Use "-o name" for shorter output (resource/name).

--raw=""
    Raw URI to DELETE to the server. Uses the transport specified by the kubeconfig file.

-R, --recursive=false
    Process the directory used in -f, --filename recursively. Useful when you want to manage related manifests organized within the same directory.

-l, --selector=""
    Selector (label query) to filter on, supports '=', '==', '!=', 'in', 'notin'.(e.g. -l key1=value1,key2=value2,key3 in (value3)). Matching objects must satisfy all of the specified label constraints.

--timeout=0s
    The length of time to wait before giving up on a delete, zero means determine a timeout from the size of the object

--wait=true
    If true, wait for resources to be gone before returning. This waits for finalizers.

OPTIONS INHERITED FROM PARENT COMMANDS

--as=""
    Username to impersonate for the operation. User could be a regular user or a service account in a namespace.

--as-group=[]
    Group to impersonate for the operation, this flag can be repeated to specify multiple groups.

--as-uid=""
    UID to impersonate for the operation.

--cache-dir="/home/username/.kube/cache"
    Default cache directory

--certificate-authority=""
    Path to a cert file for the certificate authority

--client-certificate=""
    Path to a client certificate file for TLS

--client-key=""
    Path to a client key file for TLS

--cluster=""
    The name of the kubeconfig cluster to use

--context=""
    The name of the kubeconfig context to use

--disable-compression=false
    If true, opt-out of response compression for all requests to the server

--insecure-skip-tls-verify=false
    If true, the server's certificate will not be checked for validity. This will make your HTTPS connections insecure

--kubeconfig=""
    Path to the kubeconfig file to use for CLI requests.

--match-server-version=false
    Require server version to match client version

-n, --namespace=""
    If present, the namespace scope for this CLI request

--password=""
    Password for basic authentication to the API server

--profile="none"
    Name of profile to capture. One of (none|cpu|heap|goroutine|threadcreate|block|mutex)

--profile-output="profile.pprof"
    Name of the file to write the profile to

--request-timeout="0"
    The length of time to wait before giving up on a single server request. Non-zero values should contain a corresponding time unit (e.g. 1s, 2m, 3h). A value of zero means don't timeout requests.

-s, --server=""
    The address and port of the Kubernetes API server

--tls-server-name=""
    Server name to use for server certificate validation. If it is not provided, the hostname used to contact the server is used

--token=""
    Bearer token for authentication to the API server

--user=""
    The name of the kubeconfig user to use

--username=""
    Username for basic authentication to the API server

--version=false
    --version, --version=raw prints version information and quits; --version=vX.Y.Z... sets the reported version

--warnings-as-errors=false
    Treat warnings received from the server as errors and exit with a non-zero exit code

EXAMPLE
      # Delete a pod using the type and name specified in pod.json
      kubectl delete -f ./pod.json

      # Delete resources from a directory containing kustomization.yaml - e.g. dir/kustomization.yaml
      kubectl delete -k dir

      # Delete resources from all files that end with '.json'
      kubectl delete -f '*.json'

      # Delete a pod based on the type and name in the JSON passed into stdin
      cat pod.json | kubectl delete -f -

      # Delete pods and services with same names "baz" and "foo"
      kubectl delete pod,service baz foo

      # Delete pods and services with label name=myLabel
      kubectl delete pods,services -l name=myLabel

      # Delete a pod with minimal delay
      kubectl delete pod foo --now

      # Force delete a pod on a dead node
      kubectl delete pod foo --force

      # Delete all pods
      kubectl delete pods --all

      # Delete all pods only if the user confirms the deletion
      kubectl delete pods --all --interactive

SEE ALSO

kubectl(1),

HISTORY

January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!